Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domngb.F90	(revision 9019)
@@ -11,7 +11,7 @@
    !!----------------------------------------------------------------------
    USE dom_oce        ! ocean space and time domain
+   !
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! for mppsum
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
@@ -45,10 +45,8 @@
       INTEGER , DIMENSION(2) ::   iloc
       REAL(wp)               ::   zlon, zmini
-      REAL(wp), POINTER, DIMENSION(:,:) ::  zglam, zgphi, zmask, zdist
+      REAL(wp), DIMENSION(jpi,jpj) ::   zglam, zgphi, zmask, zdist
       !!--------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dom_ngb')
-      !
-      CALL wrk_alloc( jpi,jpj,   zglam, zgphi, zmask, zdist )
+      IF( ln_timing )   CALL timing_start('dom_ngb')
       !
       zmask(:,:) = 0._wp
@@ -79,7 +77,5 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj,   zglam, zgphi, zmask, zdist )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_ngb')
+      IF( ln_timing )   CALL timing_stop('dom_ngb')
       !
    END SUBROUTINE dom_ngb
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9019)
@@ -6,6 +6,5 @@
    !! History :  2.0  !  2006-06  (B. Levier, L. Marie)  original code
    !!            3.1  !  2009-02  (G. Madec, M. Leclair, R. Benshila)  pure z* coordinate
-   !!            3.3  !  2011-10  (M. Leclair) totally rewrote domvvl:
-   !!                                          vvl option includes z_star and z_tilde coordinates
+   !!            3.3  !  2011-10  (M. Leclair) totally rewrote domvvl: vvl option includes z_star and z_tilde coordinates
    !!            3.6  !  2014-11  (P. Mathiot) add ice shelf capability
    !!----------------------------------------------------------------------
@@ -31,5 +30,4 @@
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
 
@@ -122,5 +120,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('dom_vvl_init')
+      IF( ln_timing )   CALL timing_start('dom_vvl_init')
       !
       IF(lwp) WRITE(numout,*)
@@ -242,5 +240,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_init')
+      IF( ln_timing )   CALL timing_stop('dom_vvl_init')
       !
    END SUBROUTINE dom_vvl_init
@@ -276,15 +274,12 @@
       REAL(wp)               ::   z2dt, z_tmin, z_tmax  ! local scalars
       LOGICAL                ::   ll_do_bclinic         ! local logical
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ze3t
-      REAL(wp), POINTER, DIMENSION(:,:  ) ::   zht, z_scale, zwu, zwv, zhdiv
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zht, z_scale, zwu, zwv, zhdiv
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze3t
       !!----------------------------------------------------------------------
       !
       IF( ln_linssh )   RETURN      ! No calculation in linear free surface
       !
-      IF( nn_timing == 1 )   CALL timing_start('dom_vvl_sf_nxt')
-      !
-      CALL wrk_alloc( jpi,jpj,zht,   z_scale, zwu, zwv, zhdiv )
-      CALL wrk_alloc( jpi,jpj,jpk,   ze3t )
-
+      IF( ln_timing )   CALL timing_start('dom_vvl_sf_nxt')
+      !
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
@@ -543,8 +538,5 @@
       r1_hv_a(:,:) = ssvmask(:,:) / ( hv_a(:,:) + 1._wp - ssvmask(:,:) )
       !
-      CALL wrk_dealloc( jpi,jpj,       zht, z_scale, zwu, zwv, zhdiv )
-      CALL wrk_dealloc( jpi,jpj,jpk,   ze3t )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_sf_nxt')
+      IF( ln_timing )   CALL timing_stop('dom_vvl_sf_nxt')
       !
    END SUBROUTINE dom_vvl_sf_nxt
@@ -583,5 +575,5 @@
       IF( ln_linssh )   RETURN      ! No calculation in linear free surface
       !
-      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_sf_swp')
+      IF( ln_timing )   CALL timing_start('dom_vvl_sf_swp')
       !
       IF( kt == nit000 )   THEN
@@ -657,7 +649,7 @@
       ! write restart file
       ! ==================
-      IF( lrst_oce )   CALL dom_vvl_rst( kt, 'WRITE' )
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('dom_vvl_sf_swp')
+      IF( lrst_oce  )   CALL dom_vvl_rst( kt, 'WRITE' )
+      !
+      IF( ln_timing )   CALL timing_stop('dom_vvl_sf_swp')
       !
    END SUBROUTINE dom_vvl_sf_swp
@@ -683,5 +675,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('dom_vvl_interpol')
+      IF( ln_timing )   CALL timing_start('dom_vvl_interpol')
       !
       IF(ln_wd) THEN
@@ -770,5 +762,5 @@
       END SELECT
       !
-      IF( nn_timing == 1 )   CALL timing_stop('dom_vvl_interpol')
+      IF( ln_timing )   CALL timing_stop('dom_vvl_interpol')
       !
    END SUBROUTINE dom_vvl_interpol
@@ -794,5 +786,6 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dom_vvl_rst')
+      IF( ln_timing )   CALL timing_start('dom_vvl_rst')
+      !
       IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise 
          !                                   ! ===============
@@ -947,5 +940,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_vvl_rst')
+      IF( ln_timing )   CALL timing_stop('dom_vvl_rst')
       !
    END SUBROUTINE dom_vvl_rst
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domwri.F90	(revision 9019)
@@ -24,5 +24,4 @@
    USE lbclnk          ! lateral boundary conditions - mpp exchanges
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
 
@@ -75,12 +74,9 @@
       INTEGER           ::   izco, izps, isco, icav
       !                               
-      REAL(wp), POINTER, DIMENSION(:,:)   ::   zprt, zprw     ! 2D workspace
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zdepu, zdepv   ! 3D workspace
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('dom_wri')
-      !
-      CALL wrk_alloc( jpi,jpj,       zprt , zprw  )
-      CALL wrk_alloc( jpi,jpj,jpk,   zdepu, zdepv )
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zprt, zprw     ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepu, zdepv   ! 3D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('dom_wri')
       !
       IF(lwp) WRITE(numout,*)
@@ -206,8 +202,5 @@
       !                                     ! ============================
       !
-      CALL wrk_dealloc( jpi, jpj, zprt, zprw )
-      CALL wrk_dealloc( jpi, jpj, jpk, zdepu, zdepv )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_wri')
+      IF( ln_timing )   CALL timing_stop('dom_wri')
       !
    END SUBROUTINE dom_wri
@@ -229,10 +222,8 @@
       INTEGER  ::  ji       ! dummy loop indices
       LOGICAL, DIMENSION(SIZE(puniq,1),SIZE(puniq,2),1) ::  lldbl  ! store whether each point is unique or not
-      REAL(wp), POINTER, DIMENSION(:,:) :: ztstref
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('dom_uniq')
-      !
-      CALL wrk_alloc( jpi, jpj, ztstref )
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztstref
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('dom_uniq')
       !
       ! build an array with different values for each element 
@@ -250,7 +241,5 @@
       puniq(nldi:nlei,nldj:nlej) = REAL( COUNT( lldbl(nldi:nlei,nldj:nlej,:), dim = 3 ) , wp )
       !
-      CALL wrk_dealloc( jpi, jpj, ztstref )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_uniq')
+      IF( ln_timing )   CALL timing_stop('dom_uniq')
       !
    END SUBROUTINE dom_uniq
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 9019)
@@ -36,5 +36,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
@@ -77,5 +76,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('dom_zgr')
+      IF( ln_timing )   CALL timing_start('dom_zgr')
       !
       IF(lwp) THEN                     ! Control print
@@ -164,5 +163,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dom_zgr')
+      IF( ln_timing )   CALL timing_stop('dom_zgr')
       !
    END SUBROUTINE dom_zgr
@@ -284,10 +283,8 @@
       !
       INTEGER ::   ji, jj   ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:) ::  zk
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('zgr_top_bot')
-      !
-      CALL wrk_alloc( jpi,jpj,   zk )
+      REAL(wp), DIMENSION(jpi,jpj) ::   zk   ! workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('zgr_top_bot')
       !
       IF(lwp) WRITE(numout,*)
@@ -319,7 +316,5 @@
       zk(:,:) = REAL( mbkv(:,:), wp )   ;   CALL lbc_lnk( zk, 'V', 1. )   ;   mbkv(:,:) = MAX( INT( zk(:,:) ), 1 )
       !
-      CALL wrk_dealloc( jpi,jpj,   zk )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('zgr_top_bot')
+      IF( ln_timing )   CALL timing_stop('zgr_top_bot')
       !
    END SUBROUTINE zgr_top_bot
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/dtatsd.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/dtatsd.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/dtatsd.F90	(revision 9019)
@@ -16,10 +16,10 @@
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
+   USE phycst          ! physical constants
    USE dom_oce         ! ocean space and time domain
    USE fldread         ! read input fields
+   !
    USE in_out_manager  ! I/O manager
-   USE phycst          ! physical constants
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
 
@@ -62,5 +62,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dta_tsd_init')
+      IF( ln_timing )   CALL timing_start('dta_tsd_init')
       !
       !  Initialisation
@@ -120,5 +120,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dta_tsd_init')
+      IF( ln_timing )   CALL timing_stop('dta_tsd_init')
       !
    END SUBROUTINE dta_tsd_init
@@ -145,9 +145,9 @@
       INTEGER ::   ji, jj, jk, jl, jkk   ! dummy loop indicies
       INTEGER ::   ik, il0, il1, ii0, ii1, ij0, ij1   ! local integers
-      REAL(wp)::   zl, zi
-      REAL(wp), POINTER, DIMENSION(:) ::  ztp, zsp   ! 1D workspace
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('dta_tsd')
+      REAL(wp)::   zl, zi                             ! local scalars
+      REAL(wp), DIMENSION(jpk) ::  ztp, zsp   ! 1D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('dta_tsd')
       !
       CALL fld_read( kt, 1, sf_tsd )      !==   read T & S data at kt time step   ==!
@@ -185,6 +185,4 @@
       !
       IF( ln_sco ) THEN                   !==   s- or mixed s-zps-coordinate   ==!
-         !
-         CALL wrk_alloc( jpk, ztp, zsp )
          !
          IF( kt == nit000 .AND. lwp )THEN
@@ -222,6 +220,4 @@
          END DO
          ! 
-         CALL wrk_dealloc( jpk, ztp, zsp )
-         ! 
       ELSE                                !==   z- or zps- coordinate   ==!
          !                             
@@ -260,5 +256,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dta_tsd')
+      IF( ln_timing )   CALL timing_stop('dta_tsd')
       !
    END SUBROUTINE dta_tsd
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplhsb.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplhsb.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplhsb.F90	(revision 9019)
@@ -13,16 +13,16 @@
    !!   iscpl_div      : correction of divergence to keep volume conservation
    !!----------------------------------------------------------------------
+   USE oce             ! global tra/dyn variable
    USE dom_oce         ! ocean space and time domain
    USE domwri          ! ocean space and time domain
+   USE domngb          ! 
    USE phycst          ! physical constants
    USE sbc_oce         ! surface boundary condition variables
-   USE oce             ! global tra/dyn variable
+   USE iscplini        ! 
+   !
    USE in_out_manager  ! I/O manager
    USE lib_mpp         ! MPP library
    USE lib_fortran     ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE lbclnk          !
-   USE domngb          !
-   USE iscplini
 
    IMPLICIT NONE
@@ -56,35 +56,31 @@
       REAL(wp), DIMENSION(:,:,:  ), INTENT(out) :: pvol_flx    !! corrective flux to have volume conservation
       REAL(wp),                     INTENT(in ) :: prdt_iscpl  !! coupling period 
-      !!
-      INTEGER :: ji, jj, jk                                    !! loop index
-      INTEGER :: jip1, jim1, jjp1, jjm1
-      !!
-      REAL(wp):: summsk, zsum, zsum1, zarea, zsumn, zsumb
-      REAL(wp):: r1_rdtiscpl
-      REAL(wp):: zjip1_ratio  , zjim1_ratio  , zjjp1_ratio  , zjjm1_ratio
-      !!
-      REAL(wp):: zde3t, zdtem, zdsal
-      REAL(wp), DIMENSION(:,:), POINTER :: zdssh
-      !!
-      REAL(wp), DIMENSION(:), ALLOCATABLE :: zlon, zlat
-      REAL(wp), DIMENSION(:), ALLOCATABLE :: zcorr_vol, zcorr_tem, zcorr_sal
-      INTEGER , DIMENSION(:), ALLOCATABLE :: ixpts, iypts, izpts, inpts
+      !
+      INTEGER  ::   ji  , jj  , jk           ! loop index
+      INTEGER  ::   jip1, jim1, jjp1, jjm1
+      REAL(wp) ::   summsk, zsum , zsumn, zjip1_ratio  , zjim1_ratio, zdtem, zde3t, z1_rdtiscpl
+      REAL(wp) ::   zarea , zsum1, zsumb, zjjp1_ratio  , zjjm1_ratio, zdsal
+      REAL(wp), DIMENSION(jpi,jpj)        ::   zdssh   ! workspace
+      REAL(wp), DIMENSION(:), ALLOCATABLE ::   zlon, zlat
+      REAL(wp), DIMENSION(:), ALLOCATABLE ::   zcorr_vol, zcorr_tem, zcorr_sal
+      INTEGER , DIMENSION(:), ALLOCATABLE ::   ixpts, iypts, izpts, inpts
       INTEGER :: jpts, npts
-
-      CALL wrk_alloc(jpi,jpj, zdssh )
+      !!----------------------------------------------------------------------
 
       ! get imbalance (volume heat and salt)
       ! initialisation difference
-      zde3t = 0.0_wp; zdsal = 0.0_wp ; zdtem = 0.0_wp
+      zde3t = 0._wp   ;   zdsal = 0._wp   ;   zdtem = 0._wp
 
       ! initialisation correction term
-      pvol_flx(:,:,:  ) = 0.0_wp
-      pts_flx (:,:,:,:) = 0.0_wp
+      pvol_flx(:,:,:  ) = 0._wp
+      pts_flx (:,:,:,:) = 0._wp
       
-      r1_rdtiscpl = 1._wp / prdt_iscpl 
+      z1_rdtiscpl = 1._wp / prdt_iscpl 
 
       ! mask tsn and tsb 
-      tsb(:,:,:,jp_tem)=tsb(:,:,:,jp_tem)*ptmask_b(:,:,:); tsn(:,:,:,jp_tem)=tsn(:,:,:,jp_tem)*tmask(:,:,:);
-      tsb(:,:,:,jp_sal)=tsb(:,:,:,jp_sal)*ptmask_b(:,:,:); tsn(:,:,:,jp_sal)=tsn(:,:,:,jp_sal)*tmask(:,:,:);
+      tsb(:,:,:,jp_tem) = tsb(:,:,:,jp_tem) * ptmask_b(:,:,:)
+      tsn(:,:,:,jp_tem) = tsn(:,:,:,jp_tem) *  tmask  (:,:,:)
+      tsb(:,:,:,jp_sal) = tsb(:,:,:,jp_sal) * ptmask_b(:,:,:)
+      tsn(:,:,:,jp_sal) = tsn(:,:,:,jp_sal) *  tmask  (:,:,:)
 
       !==============================================================================
@@ -118,7 +114,7 @@
 
                   ! volume, heat and salt differences in each cell 
-                  pvol_flx(ji,jj,jk)       =   pvol_flx(ji,jj,jk)        + zde3t * r1_rdtiscpl
-                  pts_flx (ji,jj,jk,jp_sal)=   pts_flx (ji,jj,jk,jp_sal) + zdsal * r1_rdtiscpl 
-                  pts_flx (ji,jj,jk,jp_tem)=   pts_flx (ji,jj,jk,jp_tem) + zdtem * r1_rdtiscpl
+                  pvol_flx(ji,jj,jk)       =   pvol_flx(ji,jj,jk)        + zde3t * z1_rdtiscpl
+                  pts_flx (ji,jj,jk,jp_sal)=   pts_flx (ji,jj,jk,jp_sal) + zdsal * z1_rdtiscpl 
+                  pts_flx (ji,jj,jk,jp_tem)=   pts_flx (ji,jj,jk,jp_tem) + zdtem * z1_rdtiscpl
 
                   ! case where we close a cell: check if the neighbour cells are wet 
@@ -184,12 +180,16 @@
       END DO
 
-      CALL lbc_sum(pvol_flx(:,:,:       ),'T',1.)
-      CALL lbc_sum(pts_flx (:,:,:,jp_sal),'T',1.)
-      CALL lbc_sum(pts_flx (:,:,:,jp_tem),'T',1.)
-
+!!gm  ERROR !!!!
+!!    juste use tmask_i  or in case of ISF smask_i (to be created to compute the sum without halos)
+!
+!      CALL lbc_sum(pvol_flx(:,:,:       ),'T',1.)
+!      CALL lbc_sum(pts_flx (:,:,:,jp_sal),'T',1.)
+!      CALL lbc_sum(pts_flx (:,:,:,jp_tem),'T',1.)
+      STOP ' iscpl_cons:   please modify this module !'
+!!gm end
       ! if no neighbour wet cell in case of 2close a cell", need to find the nearest wet point 
       ! allocation and initialisation of the list of problematic point
-      ALLOCATE(inpts(jpnij))
-      inpts(:)=0
+      ALLOCATE( inpts(jpnij) )
+      inpts(:) = 0
 
       ! fill narea location with the number of problematic point
@@ -283,13 +283,16 @@
       pts_flx (:,:,:,jp_tem) = pts_flx (:,:,:,jp_tem) * tmask(:,:,:)
 
-      ! compute sum over the halo and set it to 0.
-      CALL lbc_sum(pvol_flx(:,:,:       ),'T',1._wp)
-      CALL lbc_sum(pts_flx (:,:,:,jp_sal),'T',1._wp)
-      CALL lbc_sum(pts_flx (:,:,:,jp_tem),'T',1._wp)
-
-      ! deallocate variables
-      CALL wrk_dealloc(jpi,jpj, zdssh ) 
-
+!!gm  ERROR !!!!
+!!    juste use tmask_i  or in case of ISF smask_i (to be created to compute the sum without halos)
+!
+!      ! compute sum over the halo and set it to 0.
+!      CALL lbc_sum(pvol_flx(:,:,:       ),'T',1._wp)
+!      CALL lbc_sum(pts_flx (:,:,:,jp_sal),'T',1._wp)
+!      CALL lbc_sum(pts_flx (:,:,:,jp_tem),'T',1._wp)
+!!gm end
+
+      !
    END SUBROUTINE iscpl_cons
+
 
    SUBROUTINE iscpl_div( phdivn )
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplini.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplini.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplini.F90	(revision 9019)
@@ -11,6 +11,7 @@
    !!   iscpl_alloc    : allocation of correction variables
    !!----------------------------------------------------------------------
+   USE oce             ! global tra/dyn variable
    USE dom_oce         ! ocean space and time domain
-   USE oce             ! global tra/dyn variable
+   !
    USE lib_mpp         ! MPP library
    USE lib_fortran     ! MPP library
@@ -47,11 +48,10 @@
    END FUNCTION iscpl_alloc
 
+
    SUBROUTINE iscpl_init()
+      !!----------------------------------------------------------------------
       INTEGER ::   ios           ! Local integer output status for namelist read
-      NAMELIST/namsbc_iscpl/nn_fiscpl,ln_hsb,nn_drown
+      NAMELIST/namsbc_iscpl/ nn_fiscpl, ln_hsb, nn_drown
       !!----------------------------------------------------------------------
-      !                                   ! ============
-      !                                   !   Namelist
-      !                                   ! ============
       !
       nn_fiscpl = 0
@@ -79,7 +79,8 @@
          WRITE(numout,*) ' coupling time step                       = ', rdt_iscpl
          WRITE(numout,*) ' number of call of the extrapolation loop = ', nn_drown
-      END IF
-
+      ENDIF
+      !
    END SUBROUTINE iscpl_init
 
+   !!======================================================================
 END MODULE iscplini
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DOM/iscplrst.F90	(revision 9019)
@@ -11,18 +11,18 @@
    !!   iscpl_rst_interpol : restart interpolation in case of coupling with ice sheet
    !!----------------------------------------------------------------------
+   USE oce             ! global tra/dyn variable
    USE dom_oce         ! ocean space and time domain
    USE domwri          ! ocean space and time domain
-   USE domvvl, ONLY : dom_vvl_interpol
+   USE domvvl   , ONLY : dom_vvl_interpol
    USE phycst          ! physical constants
    USE sbc_oce         ! surface boundary condition variables
-   USE oce             ! global tra/dyn variable
+   USE iscplini        ! ice sheet coupling: initialisation
+   USE iscplhsb        ! ice sheet coupling: conservation
+   !
    USE in_out_manager  ! I/O manager
    USE iom             ! I/O module
    USE lib_mpp         ! MPP library
    USE lib_fortran     ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE lbclnk          ! communication
-   USE iscplini        ! ice sheet coupling: initialisation
-   USE iscplhsb        ! ice sheet coupling: conservation
 
    IMPLICIT NONE
@@ -50,18 +50,12 @@
       !!----------------------------------------------------------------------
       INTEGER  ::   inum0
-      REAL(wp), DIMENSION(:,:  ), POINTER ::   zsmask_b
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   ztmask_b, zumask_b, zvmask_b
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   ze3t_b  , ze3u_b  , ze3v_b  
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zdepw_b
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zsmask_b
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztmask_b, zumask_b, zvmask_b
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze3t_b  , ze3u_b  , ze3v_b  
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepw_b
       CHARACTER(20) :: cfile
       !!----------------------------------------------------------------------
-
-      CALL wrk_alloc(jpi,jpj,jpk,   ztmask_b, zumask_b, zvmask_b) ! mask before
-      CALL wrk_alloc(jpi,jpj,jpk,   ze3t_b  , ze3u_b  , ze3v_b  ) ! e3   before
-      CALL wrk_alloc(jpi,jpj,jpk,   zdepw_b )
-      CALL wrk_alloc(jpi,jpj,       zsmask_b                    )
-
-
-      !! get restart variable
+      !
+      !                       ! get restart variable
       CALL iom_get( numror, jpdom_autoglo, 'tmask'  , ztmask_b   ) ! need to extrapolate T/S
       CALL iom_get( numror, jpdom_autoglo, 'umask'  , zumask_b   ) ! need to correct barotropic velocity
@@ -72,20 +66,17 @@
       CALL iom_get( numror, jpdom_autoglo, 'e3v_n'  , ze3v_b(:,:,:) )  ! need to correct barotropic velocity
       CALL iom_get( numror, jpdom_autoglo, 'gdepw_n', zdepw_b(:,:,:) ) ! need to interpol vertical profile (vvl)
-
-      !! read namelist
-      CALL iscpl_init()
-
-      !!  ! Extrapolation/interpolation of modify cell and new cells ... (maybe do it later after domvvl)
+      !
+      CALL iscpl_init()       ! read namelist
+      !                       ! Extrapolation/interpolation of modify cell and new cells ... (maybe do it later after domvvl)
       CALL iscpl_rst_interpol( ztmask_b, zumask_b, zvmask_b, zsmask_b, ze3t_b, ze3u_b, ze3v_b, zdepw_b )
-
-      !! compute correction if conservation needed
-      IF ( ln_hsb ) THEN
+      !
+      IF ( ln_hsb ) THEN      ! compute correction if conservation needed
          IF( iscpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'rst_iscpl : unable to allocate rst_iscpl arrays' )
          CALL iscpl_cons(ztmask_b, zsmask_b, ze3t_b, htsc_iscpl, hdiv_iscpl, rdt_iscpl)
       END IF
          
-      !! print mesh/mask
-      IF( nn_msh /= 0 .AND. ln_iscpl )   CALL dom_wri      ! Create a domain file
-
+      !                       ! create  a domain file
+      IF( nn_msh /= 0 .AND. ln_iscpl )   CALL dom_wri
+      !
       IF ( ln_hsb ) THEN
          cfile='correction'
@@ -97,24 +88,18 @@
          CALL iom_close ( inum0 )
       END IF
-
-      CALL wrk_dealloc(jpi,jpj,jpk,   ztmask_b,zumask_b,zvmask_b )  
-      CALL wrk_dealloc(jpi,jpj,jpk,   ze3t_b  ,ze3u_b  ,ze3v_b   )  
-      CALL wrk_dealloc(jpi,jpj,jpk,   zdepw_b                    )
-      CALL wrk_dealloc(jpi,jpj,       zsmask_b                   )
-
-      !! next step is an euler time step
-      neuler = 0
-
-      !! set _b and _n variables equal
+      !
+      neuler = 0              ! next step is an euler time step
+      !
+      !                       ! set _b and _n variables equal
       tsb (:,:,:,:) = tsn (:,:,:,:)
       ub  (:,:,:)   = un  (:,:,:)
       vb  (:,:,:)   = vn  (:,:,:)
       sshb(:,:)     = sshn(:,:)
-
-      !! set _b and _n vertical scale factor equal
+      !
+      !                       ! set _b and _n vertical scale factor equal
       e3t_b (:,:,:) = e3t_n (:,:,:)
       e3u_b (:,:,:) = e3u_n (:,:,:)
       e3v_b (:,:,:) = e3v_n (:,:,:)
-
+      !
       e3uw_b (:,:,:) = e3uw_n (:,:,:)
       e3vw_b (:,:,:) = e3vw_n (:,:,:)
@@ -150,27 +135,16 @@
       REAL(wp):: zdz, zdzm1, zdzp1
       !!
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zdmask , zdsmask, zvcorr, zucorr, zde3t
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zbub   , zbvb   , zbun  , zbvn
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zssh0  , zssh1, zhu1, zhv1
-      REAL(wp), DIMENSION(:,:    ), POINTER :: zsmask0, zsmask1
-      REAL(wp), DIMENSION(:,:,:  ), POINTER :: ztmask0, ztmask1, ztrp
-      REAL(wp), DIMENSION(:,:,:  ), POINTER :: zwmaskn, zwmaskb, ztmp3d
-      REAL(wp), DIMENSION(:,:,:,:), POINTER :: zts0
+      REAL(wp), DIMENSION(jpi,jpj)          :: zdmask , zsmask0, zucorr, zbub, zbun, zssh0, zhu1, zde3t
+      REAL(wp), DIMENSION(jpi,jpj)          :: zdsmask, zsmask1, zvcorr, zbvb, zbvn, zssh1, zhv1
+      REAL(wp), DIMENSION(jpi,jpj,jpk)      :: ztmask0, zwmaskn, ztrp
+      REAL(wp), DIMENSION(jpi,jpj,jpk)      :: ztmask1, zwmaskb, ztmp3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts) :: zts0
       !!----------------------------------------------------------------------
-
-      !! allocate variables
-      CALL wrk_alloc(jpi,jpj,jpk,2, zts0                                   )
-      CALL wrk_alloc(jpi,jpj,jpk,   ztmask0, ztmask1 , ztrp, ztmp3d        ) 
-      CALL wrk_alloc(jpi,jpj,jpk,   zwmaskn, zwmaskb                       ) 
-      CALL wrk_alloc(jpi,jpj,       zsmask0, zsmask1                       ) 
-      CALL wrk_alloc(jpi,jpj,       zdmask , zdsmask, zvcorr, zucorr, zde3t) 
-      CALL wrk_alloc(jpi,jpj,       zbub   , zbvb    , zbun , zbvn         ) 
-      CALL wrk_alloc(jpi,jpj,       zssh0  , zssh1, zhu1, zhv1             ) 
-
-      !! mask value to be sure
+      !
+      !                 ! mask value to be sure
       tsn(:,:,:,jp_tem) = tsn(:,:,:,jp_tem) * ptmask_b(:,:,:)
       tsn(:,:,:,jp_sal) = tsn(:,:,:,jp_sal) * ptmask_b(:,:,:)
-      
-      ! compute wmask
+      !
+      !                 ! compute wmask
       zwmaskn(:,:,1) = tmask   (:,:,1)
       zwmaskb(:,:,1) = ptmask_b(:,:,1)
@@ -179,11 +153,11 @@
          zwmaskb(:,:,jk) = ptmask_b(:,:,jk) * ptmask_b(:,:,jk-1)
       END DO
-           
-      ! compute new ssh if we open a full water column (average of the closest neigbourgs)  
+      !    
+      !                 ! compute new ssh if we open a full water column (average of the closest neigbourgs)  
       sshb (:,:)=sshn(:,:)
       zssh0(:,:)=sshn(:,:)
       zsmask0(:,:) = psmask_b(:,:)
       zsmask1(:,:) = psmask_b(:,:)
-      DO iz = 1,10    ! need to be tuned (configuration dependent) (OK for ISOMIP+)
+      DO iz = 1, 10                 ! need to be tuned (configuration dependent) (OK for ISOMIP+)
          zdsmask(:,:) = ssmask(:,:)-zsmask0(:,:)
          DO jj = 2,jpj-1
@@ -198,9 +172,9 @@
                   &           + zssh0(ji,jjm1)*zsmask0(ji,jjm1))/summsk
                   zsmask1(ji,jj)=1._wp
-               END IF
+               ENDIF
             END DO
          END DO
-         CALL lbc_lnk(sshn,'T',1._wp)
-         CALL lbc_lnk(zsmask1,'T',1._wp)
+         CALL lbc_lnk( sshn   , 'T', 1._wp )
+         CALL lbc_lnk( zsmask1, 'T', 1._wp )
          zssh0   = sshn
          zsmask0 = zsmask1
@@ -210,5 +184,5 @@
 !=============================================================================
 !PM: Is this needed since introduction of VVL by default?
-      IF (.NOT.ln_linssh) THEN
+      IF ( .NOT.ln_linssh ) THEN
       ! Reconstruction of all vertical scale factors at now time steps
       ! =============================================================================
@@ -225,17 +199,17 @@
             END DO
          END DO
-
+         !
          CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:), 'U' )
          CALL dom_vvl_interpol( e3t_n(:,:,:), e3v_n(:,:,:), 'V' )
          CALL dom_vvl_interpol( e3u_n(:,:,:), e3f_n(:,:,:), 'F' )
 
-      ! Vertical scale factor interpolations
-      ! ------------------------------------
+         ! Vertical scale factor interpolations
+         ! ------------------------------------
          CALL dom_vvl_interpol( e3t_n(:,:,:), e3w_n (:,:,:), 'W'  )
          CALL dom_vvl_interpol( e3u_n(:,:,:), e3uw_n(:,:,:), 'UW' )
          CALL dom_vvl_interpol( e3v_n(:,:,:), e3vw_n(:,:,:), 'VW' )
-
-      ! t- and w- points depth
-      ! ----------------------
+         
+         ! t- and w- points depth
+         ! ----------------------
          gdept_n(:,:,1) = 0.5_wp * e3w_n(:,:,1)
          gdepw_n(:,:,1) = 0.0_wp
@@ -431,13 +405,4 @@
       ! nothing to do
       ! 
-      ! deallocation tmp arrays
-      CALL wrk_dealloc(jpi,jpj,jpk,2, zts0                                   )
-      CALL wrk_dealloc(jpi,jpj,jpk,   ztmask0, ztmask1 , ztrp                ) 
-      CALL wrk_dealloc(jpi,jpj,jpk,   zwmaskn, zwmaskb , ztmp3d              ) 
-      CALL wrk_dealloc(jpi,jpj,       zsmask0, zsmask1                       ) 
-      CALL wrk_dealloc(jpi,jpj,       zdmask , zdsmask, zvcorr, zucorr, zde3t) 
-      CALL wrk_dealloc(jpi,jpj,       zbub   , zbvb    , zbun  , zbvn        ) 
-      CALL wrk_dealloc(jpi,jpj,       zssh0  , zssh1  , zhu1 , zhv1          ) 
-      !
    END SUBROUTINE iscpl_rst_interpol
 
